#include "CSemCond.h"
#include <iostream>
#include <errno.h>
#include <assert.h>

CSemCond::CSemCond()
{
	semID = semget(IPC_PRIVATE, 1, IPC_CREAT|IPC_EXCL|0600);
	if (-1 == semctl(semID, 0, SETVAL, 1)) perror("semaphore constructor");
	semOp.sem_num = 0;
	semOp.sem_flg = SEM_UNDO;
}

CSemCond::~CSemCond()
{
	semctl(semID, 1, IPC_RMID, 0);
}

bool CSemCond::await(CSemMutex *mutex, char what)
{
	int result;

	std::cout << "W" << what << std::endl << std::flush;
	semOp.sem_op = -1;

	if (-1 == semop(semID, &semOp, 1)) perror("await1");
	
	result = semctl(semID, 0, GETVAL, NULL);
	assert(0 == result);

	mutex->unlock();
	if (-1 == semop(semID, &semOp, 1)) perror("await2");

	mutex->lock();
	result = semctl(semID, 0, GETVAL, NULL);
	assert(0 == result);
	
	semOp.sem_op = 1;
	if (-1 == semop(semID, &semOp, 1)) perror("await3");

	return true;
}

bool CSemCond::signal(char what)
{
	int result;
	
	result = semctl(semID, 0, GETVAL, NULL);
	if (-1 == result) perror("signal1");
	if (result != 0) return false;
	
	std::cout << "S" << what << std::endl << std::flush;
//	std::cout << "S1 ID" << semID << std::endl << std::flush;
	semOp.sem_flg = SEM_UNDO;
	semOp.sem_op = 1;
	if (-1 == semop(semID, &semOp, 1)) perror("signal2");
//	std::cout << "S2" << std::endl << std::flush;

	return true;
}

bool CSemCond::destroy()
{
	if (-1 == semctl(semID, 1, IPC_RMID, 0)) {
		perror("destroy");
		return false;
	} else
		return true;
}
