#include "CSemMutex.h"
#include <iostream>
#include <errno.h>
#include <assert.h>

CSemMutex::CSemMutex()
{
	semID = semget(IPC_PRIVATE, 1, IPC_CREAT|IPC_EXCL|0600);
	
	if (-1 == semctl(semID, 0, SETVAL, 1)) perror("mutex constructor");
	
	semOp.sem_num = 0;
	semOp.sem_flg = SEM_UNDO;
}

CSemMutex::~CSemMutex()
{
	semctl(semID, 1, IPC_RMID, 0);
}

bool CSemMutex::lock()
{
	int result;
	
	semOp.sem_op = -1;
	if (-1 == semop(semID, &semOp, 1)) perror("locking");
	
	result = semctl(semID, 0, GETVAL, NULL);
	
	std::cout << "L " << semID << "  V" << result << std::endl << std::flush;

	assert(result == 0);
	
	return true;
}

bool CSemMutex::unlock()
{
	int result;
	
	result = semctl(semID, 0, GETVAL, NULL);
	assert(result == 0);
	
	std::cout << "U " << semID << std::endl << std::flush;
	semOp.sem_op = 1;
	if (-1 == semop(semID, &semOp, 1)) perror("unlock");
	
	return true;
}

bool CSemMutex::destroy()
{
	semctl(semID, 1, IPC_RMID, 0);
	
	return true;
}
