#ifndef COMMQUEUE_H_
#define COMMQUEUE_H_ COMMQUEUE_H_

#include "CMessage.h"
#include "CSemCond.h"
#include "CSemMutex.h"
#include <iostream>

class CommQueue
{
public:
	CommQueue(int queuesize);
	~CommQueue();
	
	bool add(const CMessage* msg);
	bool getMessage(CMessage* msg);
	int getNumOfMessages(void);
	int getNumOfByteNeeded(void);
	bool destroy();
	
private:
	int mSize;
	int mCurrentSize;
	int mHeadIndex;
	int mTailIndex;
	unsigned int canary1;
	CSemMutex comm_mutex;
	unsigned int canary2;
	CSemCond canWrite_cond;
	unsigned int canary3;
	CSemCond canRead_cond;
	unsigned int canary4;
	struct CMessage mQueue[1];
};

#endif /*COMMQUEUE_H_*/
